package webapps.ajax1.grid;

/**
 * Write a description of class SSOption here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class SSOption {
    private String name;
    private String dataType;
    private String defaultValue;
    private String value;
    private boolean mandatory=false;
    // constructors
    public SSOption() {
        this(null);
    }
    public SSOption(String n) {
        this(n,null);
    }
    public SSOption(String n,String dt) {
        this(n,dt,null);
    }
    public SSOption(String n,String dt,String df) {
        this(n,dt,df,null);
    }
    public SSOption(String n,String dt,String df,String v) {
        this(n,dt,df,v,false);
    }
    public SSOption(String n,String dt,String df,String v,boolean m) {
        setName(n);setDataType(dt);setDefaultValue(df);setValue(v);setMandatory(m);
    }
    //setters
    public void setName(String s) { name=s; }
    public void setDataType(String dt) { dataType=dt; }
    public void setDefaultValue(String df) { defaultValue=df; }
    public void setValue(String v) { value=v; }
    public void setMandatory(boolean m) { mandatory=m; }
    //getters
    public String getName() { return name; }
    public String getDataType() { return dataType; }
    public String getDefaultValue() { return defaultValue; }
    public String getValue() { return value; }
    public boolean getMandatory() { return mandatory; }
    public boolean isMandatory() { return getMandatory(); }
    //custom
    public String generate() {
//if ( getName().equals("title") ) System.out.println("SSOption.generate(title) dt="+getDataType()+" mandatory="+getMandatory());        
        if ( getValue() == null ) return null;
        if ( getName() == null ) return null;
        if ( !isMandatory() ) return null;
        StringBuffer sb = new StringBuffer();
        sb.append("\""+getName()+"\":");
        if (getDataType() != null && (getDataType().equals("string") || getDataType().equals("percentage") )) sb.append("\"");
        sb.append(getValue());
        if (getDataType() != null && (getDataType().equals("string") || getDataType().equals("percentage") )) sb.append("\"");
//if ( getName().equals("title") ) System.out.println("SSOption.generate(title)="+sb.toString());        
        return sb.toString();
    }
    // override
    @Override
    public int hashCode() {
        return getName().hashCode();
    }
    @Override
    public boolean equals(Object obj) {
        return ((SSOption) obj).getName().equals(getName());
    }
    @Override
    public String toString() {
        return generate();
    }
}
